//---------------------------------
// Notes: comments are // or /* */  0x### is hex 0## is oct ### is dec
// $# is a register.  db., dh. dw. (Data byte, hword, word) ds. (data string),
// org. (origin of the code that folows).   Zipo error handling so be carful,
// it should choke up a line number for you....


//--------------------------------------
//All programs Need an org. statment now...
//The First org. is the base for all orgs. (After that your offseting into the .obj file..)
        org. 0x07000000

//---------------------------------------
// V810 test asm file
//---------------------------------------
// Test out our Data PreComp codes...
        db. 10, 0x10, 20, 0x20 // Store 4 bytes
        dh. 10, 0x10, 20, 0x20 // store 4 HWords (8Bytes)
        dw. 10, 0x10, 20, 0x20 // Store 4 Words (16Bytes)
        ds. "Bob lives hear"   // Stor a string (Ascii Text)
// Comming soon named constants... like #define in C
//      dlb. bob 0x10  // Define Literal Byte...
//      dlh. frank 0x20

//-----------------------------------
        org. 0x07000100  // Code Starts Hear (code can start anywear thoe...)
                                         // Remember to never jump to an odd org with instructions folowing
                                         // Always mask the first 2 bits to zero (Its ok, if no code folows thoe,
                                         // like defining a string or sutch...)

//----------------------------------
// list of all instructions:
// MODE1
        mov     $1, $2
        add     $1, $2
        sub     $1, $2
        cmp     $1, $2
        shl     $1, $0
        shr     $1, $0
        jmp     [$1]
        sar     $1, $2
        mul     $1, $2
        div     $1, $2
        mulu    $1, $2
        divu    $1, $2
        or      $1, $2
        and     $1, $2
        xor     $1, $2
        not     $1, $2

//MODE2
        mov     256, $2
        add     0x3f, $3
        setf    023, $1
        cmp     -34, $3
        shl     2, $3
        shr     2, $3
        ei      
        sar     -0x3F, $2
        trap    2
        ldsr    $2, $2
        stsr    $2, $2
        di      

//MODE3
        bv      0
        bl      0
        be      0
        bnh     0
        bn      0
        br      0
        blt     0
        ble     0
        bnv     0
        bnl     0
        bne     0
        bh      0
        bp      0
        nop     0
        bge     0
        bgt     0

//MODE4
        jr      0
        jal     0

//MODE5
        movea   2, $1, $2
        addi    2, $2, $3
        ori     2, $2, $3
        andi    2, $1, $2
        xori    3, $2, $1
        movhi   3, $2, $1

//MODE6A
        ld.b    4[$1], $2
        ld.h    4[$1], $2
        ld.w    4[$1], $2
        in.b    4[$1], $2
        in.h    4[$1], $2
        in.w    4[$1], $2
        caxi    4[$1], $2

//MODE6B
        st.b    $2, 4[$1]
        st.h    $2, 4[$1]
        st.w    $2, 4[$1]
        out.b   $2, 4[$1]
        out.h   $2, 4[$1]
        out.w   $2, 4[$1]

//MODE9
        reti    
        halt    

//----------------------------------------------
// Misc Test routines:


        add             0x1, $10
        add             $3, $10
        add             -1, $10

        movea           0x8000, $4, $4
        mov             $0, $7
        movhi           0x200, $0, $8
        movea           24, $8, $6
        st.b            $7, 0x0[$6]
        movhi           0x1, $0, $1
        movea           0xffff, $1, $10
        add             -1, $10
        bne             -2
        mov             -1, $8
        movhi           -0x1, $0, $1
        movea           0x8000, $1, $7
        movhi           2, $0, $6
        jal             270
        mov             $0, $8
        movhi           1, $0, $1
        movea           8000, $1, $7
        movhi           0, $0, $6
        jal             252
        mov             $0, $8
        movea           4000, $0, $7
        movhi           500, $0, $6
        jal             238
        movhi           0xfff9, $0, $1
        movea           0x908c, $1, $1
        jmp             [$1]
        jal             103588
        ld.w            0[$3], $1
        add             4, $3
        reti
        add             -4, $3
        st.w            $1, 0[$3]
        mov             $0, $1
        movhi           2, $0, $1
        ldsr            5, $1
        mov             2, $1
        ldsr            -8, $1
        ld.w            0[$3], $1
        add             4, $3
        jmp             [$31]
        addi            0xffec, $3, $3
        st.w            $31, 16[$3]
        mov             0, $10
        st.h            $10, -21998[$4]
        st.h            $10, -21996[$4]


        org. 0x07001000        
        ds. "Thats all Folks, 0x07001000"
 //-------------------------------------------------

 // Rom Info...         
        org. 0x07001DE0 // Game Title, 20 chrs...
        ds.  "V.TEST              "
        
        org. 0x07001DF4 // Reserved
        db.  00, 00, 00, 00, 00
        
        org. 0x07001DF9 // Manufac Code
        ds.  "8B"
        
        org. 0x07001DFB //Game Code
        ds.  "VTST"
        
        org. 0x07001DFF // Rom Ver
        db.  00

 // Int Handlers...
        org. 0x07001E00  // Key Interupt
        org. 0x07001E10  // Timer Interupt
        org. 0x07001E20  // Expantion Port Interupt?
        org. 0x07001E30  // Link Port Interupt
        org. 0x07001E40  // Video Proc Interupt
        
// Reset Vector... 
        org. 0x07001FF0 
        //Add a reset vector to the end...
        movhi           0x0700, $0, $1   //upper address of jump
        movea           0x0100, $1, $1   //lower address of jump
        jmp             [$1]             //Jump to 0x0700 0100
        nop                                      // Fluf, any code so that this takes 
        nop                                      // Up exactly 16 bytes
        nop
       
        
        
